ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.1 by root, Mon Dec 6 19:33:58 2010 UTC vs.
Revision 1.23 by root, Sat Dec 18 13:58:12 2010 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6PERLVER=5.12.2 # 5.8.9 is also a good choice
7STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
8CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
9EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
10 9
11MKBUNDLE="$STATICPERL/mkbundle"
12
13# perl build variables 10# perl build variables
14PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
28 ;; 28 ;;
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 36
37# some configuration options for modules 37# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 38export PERL_MM_USE_DEFAULT=1
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41 41
42# which extra modules to install by default from CPAN that are 42# which extra modules to install by default from CPAN that are
43# required by mkbundle 43# required by mkbundle
44EXTRA_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45
46# which extra modules you might want to install
47EXTRA_MODULES=""
45 48
46# overridable functions 49# overridable functions
50preconfigure() { : ; }
47postconfigure() { : ; } 51postconfigure() { : ; }
48postbuild() { : ; } 52postbuild() { : ; }
49postinstall() { : ; } 53postinstall() { : ; }
50 54
51# now source user config, if any 55# now source user config, if any
56if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC"
58else
52[ -r /etc/staticperlrc ] && . /etc/staticperlrc 59 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
53[ -r ~/.staticperlrc ] && . ~/.staticperlrc 60 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
54[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 61 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
62fi
55 63
56############################################################################# 64#############################################################################
57# support 65# support
66
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side
58 72
59# set version in a way that Makefile.PL can extract 73# set version in a way that Makefile.PL can extract
60VERSION=VERSION; eval \ 74VERSION=VERSION; eval \
61$VERSION=0.1 75$VERSION=0.912
62 76
63BZ2=bz2 77BZ2=bz2
64BZIP2=bzip2 78BZIP2=bzip2
65 79
66fatal() { 80fatal() {
99############################################################################# 113#############################################################################
100# clean 114# clean
101 115
102distclean() { 116distclean() {
103 verblock <<EOF 117 verblock <<EOF
104deleting everything installed by this script 118 deleting everything installed by this script (rm -rf $STATICPERL)
105EOF 119EOF
106 120
107 rm -rf "$STATICPERL" 121 rm -rf "$STATICPERL"
108} 122}
109 123
110############################################################################# 124#############################################################################
111# download/configure/compile/install perl 125# download/configure/compile/install perl
112 126
113clean() { 127clean() {
114 cd "$STATICPERL/src/perl-$PERLVER" 2>/dev/null || return 128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129}
115 130
116 rm -f staticstamp.configure 131realclean() {
117 make distclean >/dev/null 2>&1 132 rm -f "$PERL_PREFIX/staticstamp.postinstall"
133 rm -f "$PERL_PREFIX/staticstamp.install"
134 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
118} 135}
119 136
120fetch() { 137fetch() {
121 rcd "$STATICPERL" 138 rcd "$STATICPERL"
122 139
123 mkdir -p src 140 mkdir -p src
124 rcd src 141 rcd src
125 142
126 if ! [ -d "perl-$PERLVER" ]; then 143 if ! [ -d "perl-$PERL_VERSION" ]; then
127 if ! [ -e "perl-$PERLVER.tar.$BZ2" ]; then 144 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then
128 145
129 URL="$CPAN/src/5.0/perl-$PERLVER.tar.$BZ2" 146 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2"
130 147
131 verblock <<EOF 148 verblock <<EOF
132downloading perl 149downloading perl
133to manually download perl yourself, place 150to manually download perl yourself, place
134perl-$PERLVER.tar.$BZ2 in $STATICPERL 151perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
135trying $URL 152trying $URL
136EOF 153EOF
137 154
138 curl >perl-$PERLVER.tar.$BZ2~ "$URL" \ 155 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
139 || wget -O perl-$PERLVER.tar.$BZ2~ "$URL" \ 156 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
157 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
140 || fatal "$URL: error during downloading" 158 || fatal "$URL: unable to download"
159 rm -f perl-$PERL_VERSION.tar.$BZ2
141 mv perl-$PERLVER.tar.$BZ2~ perl-$PERLVER.tar.$BZ2 160 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
142 fi 161 fi
143 162
144 verblock <<EOF 163 verblock <<EOF
145unpacking perl 164unpacking perl
146EOF 165EOF
147 166
148 mkdir -p unpack 167 mkdir -p unpack
168 rm -rf unpack/perl-$PERL_VERSION
149 $BZIP2 -d <perl-$PERLVER.tar.bz2 | tar xpC unpack \ 169 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
150 || fatal "perl-$PERLVER.tar.bz2: error during unpacking" 170 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
171 chmod -R u+w unpack/perl-$PERL_VERSION
151 mv unpack/perl-$PERLVER perl-$PERLVER 172 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
152 rmdir -p unpack 173 rmdir -p unpack
153 fi 174 fi
154} 175}
155 176
156# similar to GNU-sed -i or perl -pi 177# similar to GNU-sed -i or perl -pi
157sedreplace() { 178sedreplace() {
158 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 179 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
180 rm -f "$2"
159 mv "$2~" "$2" 181 mv "$2~" "$2"
182}
183
184configure_failure() {
185 cat <<EOF
186
187
188***
189*** Configure failed - see above for the exact error message(s).
190***
191*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
192*** flags are not supported by your compiler. Less often, this is because
193*** PERL_LIBS either contains a library not available on your system (such as
194*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
195***
196*** You can provide your own flags by creating a ~/.staticperlrc file with
197*** variable assignments. For example (these are the actual values used):
198***
199
200PERL_CC="$PERL_CC"
201PERL_CCFLAGS="$PERL_CCFLAGS"
202PERL_OPTIMIZE="$PERL_OPTIMIZE"
203PERL_LDFLAGS="$PERL_LDFLAGS"
204PERL_LIBS="$PERL_LIBS"
205
206EOF
207 exit 1
160} 208}
161 209
162configure() { 210configure() {
163 fetch 211 fetch
164 212
165 rcd "$STATICPERL/src/perl-$PERLVER" 213 rcd "$STATICPERL/src/perl-$PERL_VERSION"
166 214
167 [ -e staticstamp.configure ] && return 215 [ -e staticstamp.configure ] && return
168 216
169 verblock <<EOF 217 verblock <<EOF
170configuring $STATICPERL/src/perl-$PERLVER 218configuring $STATICPERL/src/perl-$PERL_VERSION
171EOF 219EOF
172 220
173 clean
174
175 rm -f "$PREFIX/staticstamp.install" 221 rm -f "$PERL_PREFIX/staticstamp.install"
176 222
223 "$MAKE" distclean >/dev/null 2>&1
224
225 sedreplace '/^#define SITELIB/d' config_h.SH
226
177 # I hate them 227 # I hate them for this
178 grep -q -- -fstack-protector Configure && \ 228 grep -q -- -fstack-protector Configure && \
179 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 229 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
230
231 preconfigure
180 232
181# trace configure \ 233# trace configure \
182 sh Configure -Duselargefiles \ 234 sh Configure -Duselargefiles \
183 -Uuse64bitint \ 235 -Uuse64bitint \
184 -Dusemymalloc=n \ 236 -Dusemymalloc=n \
185 -Uusedl \ 237 -Uusedl \
186 -Uusethreads \ 238 -Uusethreads \
187 -Uuseithreads \ 239 -Uuseithreads \
188 -Uusemultiplicity \ 240 -Uusemultiplicity \
189 -Duseperlio \
190 -Uusesfio \ 241 -Uusesfio \
191 -Uuseshrplib \ 242 -Uuseshrplib \
192 -Dcppflags="$PERL_CPPFLAGS" \ 243 -A ccflags=" $PERL_CCFLAGS" \
193 -Dccflags="-g2 -fno-strict-aliasing" \ 244 -Dcc="$PERL_CC" \
194 -Doptimize="$PERL_OPTIMIZE" \ 245 -Doptimize="$PERL_OPTIMIZE" \
195 -Dldflags="$PERL_LDFLAGS" \ 246 -Dldflags="$PERL_LDFLAGS" \
196 -Dlibs="$PERL_LIBS" \ 247 -Dlibs="$PERL_LIBS" \
197 -Dprefix="$PREFIX" \ 248 -Dprefix="$PERL_PREFIX" \
198 -Dbin="$PREFIX/bin" \ 249 -Dbin="$PERL_PREFIX/bin" \
199 -Dprivlib="$PREFIX/plib" \ 250 -Dprivlib="$PERL_PREFIX/lib" \
200 -Darchlib="$PREFIX/plib" \ 251 -Darchlib="$PERL_PREFIX/lib" \
201 -Uusevendorprefix \ 252 -Uusevendorprefix \
202 -Dsitelib="$PREFIX/plib" \ 253 -Dsitelib="$PERL_PREFIX/lib" \
203 -Dsitearch="$PREFIX/plib" \ 254 -Dsitearch="$PERL_PREFIX/lib" \
204 -Usitelibexp \
205 -Uman1dir \ 255 -Uman1dir \
206 -Uman3dir \ 256 -Uman3dir \
207 -Usiteman1dir \ 257 -Usiteman1dir \
208 -Usiteman3dir \ 258 -Usiteman3dir \
209 -Dpager=/usr/bin/less \ 259 -Dpager=/usr/bin/less \
210 -Demail="$EMAIL" \ 260 -Demail="$EMAIL" \
211 -Dcf_email="$EMAIL" \ 261 -Dcf_email="$EMAIL" \
212 -Dcf_by="$EMAIL" \ 262 -Dcf_by="$EMAIL" \
263 $PERL_CONFIGURE \
264 -Duseperlio \
213 -dE || fatal "Configure failed" 265 -dE || configure_failure
214 266
215 sedreplace ' 267 sedreplace '
216 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 268 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
217 s/ *-fno-stack-protector */ /g 269 s/ *-fno-stack-protector */ /g
218 ' config.sh 270 ' config.sh
225} 277}
226 278
227build() { 279build() {
228 configure 280 configure
229 281
230 rcd "$STATICPERL/src/perl-$PERLVER" 282 rcd "$STATICPERL/src/perl-$PERL_VERSION"
231 283
232 verblock <<EOF 284 verblock <<EOF
233building $STATICPERL/src/perl-$PERLVER 285building $STATICPERL/src/perl-$PERL_VERSION
234EOF 286EOF
235 287
236 rm -f "$PREFIX/staticstamp.install" 288 rm -f "$PERL_PREFIX/staticstamp.install"
237 289
238 make || fatal "make: error while building perl" 290 "$MAKE" || fatal "make: error while building perl"
239 291
240 postbuild || fatal "postbuild hook failed" 292 postbuild || fatal "postbuild hook failed"
241} 293}
242 294
243install() { 295install() {
244 [ -e "$PREFIX/staticstamp.install" ] && return 296 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
245
246 build 297 build
247 298
248 verblock <<EOF 299 verblock <<EOF
249installing $STATICPERL/src/perl-$PERLVER 300installing $STATICPERL/src/perl-$PERL_VERSION
250to $PREFIX 301to $PERL_PREFIX
251EOF 302EOF
252 303
253 rm -rf "$PREFIX" 304 ln -sf "perl/bin/" "$STATICPERL/bin"
254 305 ln -sf "perl/lib/" "$STATICPERL/lib"
306
307 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
308 rm -rf "$PERL_PREFIX" # by this rm -rf
309
255 make install || fatal "make install: error while installing" 310 "$MAKE" install || fatal "make install: error while installing"
256 311
312 rcd "$PERL_PREFIX"
313
257 # create a "make install" replacement for CPAN 314 # create a "make install" replacement for CPAN
258 cat >"$PREFIX"/bin/cpan-make-install <<EOF 315 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
259make install UNINST=1 316"$MAKE" || exit
317
260if find blib/arch/auto -type f | grep -q -v .exists; then 318if find blib/arch/auto -type f | grep -q -v .exists; then
261 echo Probably an XS module, rebuilding perl 319 echo Probably an XS module, rebuilding perl
262 make perl 320 if "$MAKE" perl; then
321 mv perl "$PERL_PREFIX"/bin/perl~ \
263 rm -f "$PREFIX"/bin/perl 322 && rm -f "$PERL_PREFIX"/bin/perl \
264 make -f Makefile.aperl inst_perl 323 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
265 make -f Makefile.aperl map_clean 324 "$MAKE" -f Makefile.aperl map_clean
325 else
326 "$MAKE" -f Makefile.aperl map_clean
327 exit 1
328 fi
266fi 329fi
330
331"$MAKE" install UNINST=1
267EOF 332EOF
268 chmod 755 "$PREFIX"/bin/cpan-make-install 333 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
269 334
335 # trick CPAN into avoiding ~/.cpan completely
336 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
337
270 "$PREFIX"/bin/perl -MCPAN -e ' 338 "$PERL_PREFIX"/bin/perl -MCPAN -e '
271 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 339 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
272 CPAN::Shell->o (conf => q<init>);
273 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 340 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
341 CPAN::Shell->o (conf => q<init>);
342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
274 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 343 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
275 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 344 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
276 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 345 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
277 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 346 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
278 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PREFIX"'/bin/cpan-make-install"); 347 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
279 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 348 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
280 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 349 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
281 CPAN::Shell->o (conf => q<commit>); 350 CPAN::Shell->o (conf => q<commit>);
282 ' || fatal "error while initialising CPAN" 351 ' || fatal "error while initialising CPAN"
283 352
353 touch "$PERL_PREFIX/staticstamp.install"
354 fi
355
356 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
284 NOCHECK_INSTALL=+ 357 NOCHECK_INSTALL=+
285 instcpan $EXTRA_MODULES 358 instcpan $STATICPERL_MODULES
359 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
286 360
287 postinstall || fatal "postinstall hook failed" 361 postinstall || fatal "postinstall hook failed"
288 362
289 touch "$PREFIX/staticstamp.install" 363 touch "$PERL_PREFIX/staticstamp.postinstall"
364 fi
290} 365}
291 366
292############################################################################# 367#############################################################################
293# install a module from CPAN 368# install a module from CPAN
294 369
299installing modules from CPAN 374installing modules from CPAN
300$@ 375$@
301EOF 376EOF
302 377
303 for mod in "$@"; do 378 for mod in "$@"; do
304 "$PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 379 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \
305 || fatal "$mod: unable to install from CPAN" 380 || fatal "$mod: unable to install from CPAN"
306 done 381 done
307 rm -rf "$STATICPERL/build" 382 rm -rf "$STATICPERL/build"
308} 383}
309 384
321 for mod in "$@"; do 396 for mod in "$@"; do
322 echo 397 echo
323 echo $mod 398 echo $mod
324 ( 399 (
325 rcd $mod 400 rcd $mod
326 make -f Makefile.aperl map_clean >/dev/null 2>&1 401 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
327 make distclean >/dev/null 2>&1 402 "$MAKE" distclean >/dev/null 2>&1
328 "$PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 403 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
329 make || fatal "$mod: error building module" 404 "$MAKE" || fatal "$mod: error building module"
330 "$PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 405 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
331 make distclean >/dev/null 2>&1 406 "$MAKE" distclean >/dev/null 2>&1
332 exit 0 407 exit 0
333 ) || exit $? 408 ) || exit $?
334 done 409 done
335} 410}
336 411
337############################################################################# 412#############################################################################
338# do schmorpy stuff
339
340MODSRCDIR=~/src
341
342instmodsrc() {
343 for mod in "$@"; do
344 instmod_src "$MODSRCDIR/$mod"
345 done
346}
347
348install_schmorp() {
349 install
350
351 instcpan Data::Dump Term::ReadLine::Perl Term::ANSIColor Term::ReadKey
352 instcpan Digest::SHA Digest::MD6 Digest::SHA256 Digest::MD4 Digest::HMAC_MD5 Digest::HMAC_MD6 Digest::FNV
353 #instcpan Net::SSLeay # requires static -ldl
354
355 instmodsrc common-sense Crypt-Twofish2 Array-Heap Convert-Scalar Compress-LZF JSON-XS
356 instmodsrc EV Guard Async-Interrupt IO-AIO
357 instmodsrc AnyEvent AnyEvent-AIO Coro AnyEvent-HTTP
358 instmodsrc Linux-Inotify2 EV-Loop-Async
359
360 instcpan AnyEvent::HTTPD
361}
362
363#############################################################################
364# main 413# main
365 414
366podusage() { 415podusage() {
367 echo 416 echo
417
368 if [ -e "$PREFIX/bin/perl" ]; then 418 if [ -e "$PERL_PREFIX/bin/perl" ]; then
369 "$PREFIX/bin/perl" -MPod::Usage -e \ 419 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
370 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 420 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
371 2>/dev/null && exit 421 2>/dev/null && exit
372 fi 422 fi
423
373 # try whatever perl we can find 424 # try whatever perl we can find
374 perl -MPod::Usage -e \ 425 perl -MPod::Usage -e \
375 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 426 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
376 2>/dev/null && exit 427 2>/dev/null && exit
377 428
378 fatal "displaying documentation requires a working perl - try '$0 install' first" 429 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
379} 430}
380 431
381usage() { 432usage() {
382 podusage 0 433 podusage 0
383} 434}
384 435
385catmkbundle() { 436catmkbundle() {
386 { 437 {
387 read dummy 438 read dummy
388 echo "#!$PREFIX/bin/perl" 439 echo "#!$PERL_PREFIX/bin/perl"
389 cat 440 cat
390 } <<'MKBUNDLE' 441 } <<'MKBUNDLE'
391#CAT mkbundle 442#CAT mkbundle
392MKBUNDLE 443MKBUNDLE
393} 444}
394 445
395bundle() { 446bundle() {
396 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 447 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
397 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 448 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
449 CACHE="$STATICPERL/cache"
450 mkdir -p "$CACHE"
398 "$PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 451 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
399} 452}
400 453
401if [ $# -gt 0 ]; then 454if [ $# -gt 0 ]; then
402 while [ $# -gt 0 ]; do 455 while [ $# -gt 0 ]; do
403 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 456 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
404 mkdir -p "$PREFIX" || fatal "$PREFIX: cannot create" 457 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
405 458
406 command="${1#--}"; shift 459 command="${1#--}"; shift
407 case "$command" in 460 case "$command" in
461 version )
462 echo "staticperl version $VERSION"
463 ;;
408 fetch | configure | build | install | clean | distclean) 464 fetch | configure | build | install | clean | realclean | distclean)
409 verblock <<EOF
410$command
411EOF
412 "$command" 465 ( "$command" ) || exit
413 ;; 466 ;;
414 instsrc ) 467 instsrc )
415 instsrc "$@" 468 ( instsrc "$@" ) || exit
416 exit 469 exit
417 ;; 470 ;;
418 instcpan ) 471 instcpan )
419 instcpan "$@" 472 ( instcpan "$@" ) || exit
420 exit 473 exit
421 ;; 474 ;;
422 instschmorp )
423 install_schmorp
424 ;;
425 cpan ) 475 cpan )
426 install 476 ( install ) || exit
427 "$PREFIX/bin/cpan" "$@" 477 "$PERL_PREFIX/bin/cpan" "$@"
428 exit 478 exit
429 ;; 479 ;;
430 mkbundle ) 480 mkbundle )
431 install 481 ( install ) || exit
432 bundle "$@" 482 bundle "$@"
433 exit 483 exit
434 ;; 484 ;;
435 mkperl ) 485 mkperl )
436 install 486 ( install ) || exit
437 bundle --perl "$@" 487 bundle --perl "$@"
488 exit
489 ;;
490 mkapp )
491 ( install ) || exit
492 bundle --app "$@"
438 exit 493 exit
439 ;; 494 ;;
440 help ) 495 help )
441 podusage 2 496 podusage 2
442 ;; 497 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines